#!/usr/bin/perl -w
# perl 050_NucSeqPickerFromAASeq.pl > output
# local Blast を用いて，AAseq をクエリとして該当する cDNA を抽出するスクリプト．
# tblastn でベストマッチの塩基配列を見つけて，その acc num を用いて fastacmd で塩基配列を引き出す．
# NCBI の nr と nt データベースが local Blast として設定されている必要がある．-d のアドレスを適宜変更する．
# NCBI のウェブサイトを用いて，その種の gi number をあつめて，あらかじめファイルとして保存しておく．

use strict;
use warnings;

my $queryseqAA = "SeqUrchinAA";    # クエリ，アミノ酸配列
my $blastRes = "050_Out_NucGiNums.txt";   # local blast の結果．
my $giList = "gi";
my $Num_blastResSeq = 1;           # blast search で結果として得られる配列の数を指定する．

my $queryName = "";
my $giNum = "";


##### AAseq をクエリとして，塩基配列データベースを Blast seqrch している．
system("blastall -i $queryseqAA -d NCBI/nt/nt -o $blastRes -p tblastn -l $giList -e 1 -b $Num_blastResSeq -m 9");

#-b で取ってくる配列の数を指定している．


##### 上の Blast seqrch で得られた結果である $blastRes から，塩基配列の accession number をとってきて，fastacmd で該当する配列を取ってくる．
open(BLRES,"$blastRes");
while(my $line = <BLRES>){
  if($line !~ /^#/){
#    $line =~ /^(.*?).*?gi|(\d+)|.*$/;
    $line =~ /^(.*?)\t.*?gi\|(\d+)\|.*$/;
    $queryName = $1;
    $giNum = $2;
    print ">>AAseqGi:$queryName; NucSeqGi:$giNum\n";
    system("fastacmd -d NCBI/nt/nt -s $giNum");
    print "\n";
  }
}
close BLRES;
